"use strict";

let my_login = null;
let token = null;

function change_path(path) {
    document.getElementById("content-drive").innerHTML = "";
    $.ajax({url: 'change-path'+path+"/"+token, success: function(result){
        let p = path.split("/");
        if (p.length === 2){
            p = null;
        } else {
            p.pop()
            p = p.join("/");
        }
        appendLinkToParent(path, p);
        for (let i in result){
            if (result[i].file_id){
                new_file(result[i].file_name, result[i].file_id, "content-drive");
            } else {
                if (path !== result[i].paths){
                    let name = result[i].paths.split("/");
                    new_folder(name[name.length-1], result[i].paths);
                }
            }
        }
    }});
}

function appendLinkToParent(path, parent) {
    let el = document.getElementById("dir_name");
    let btn = ""
    if (parent) {
        btn = `<button onclick="change_path('${parent}')"><-</button>`;
    }
    el.innerHTML = `
        <p>Directory :</p> 
        <p id="path-dir-drive">${path}</p>
        ${btn}
    `;

}

function login() {
    let username = document.getElementById("username").value
    let passwd = document.getElementById("passwd").value

    $.ajax({url: 'login?user='+username+'&pass='+passwd, success: function(result){
        my_login = username;
        token = result.signedToken;
        change_path('/' + username);
        let el = document.getElementById("login-button");
        el.innerHTML = "Disconnect";
        el.onclick = disconnect;
        document.getElementById("menu-more").style.display = "block";
    }});
}

function disconnect(){
    $.ajax({url: 'logout?token=' + token, success: function(result){
        token = null;
        let el = document.getElementById("login-button");
        el.innerHTML = "Login";
        el.onclick = login;
        document.getElementById("content-drive").innerHTML = "";
        document.getElementById("dir_name").innerHTML = "";
        document.getElementById("menu-more").style.display = "none";
    }});
}

function showSharedContent() {
    let el = document.getElementById("shared-content");
    $.ajax({url: '/show-shared-file?token=' + token,
        success: function(result){
            console.log(result);
            for (let i in result){
                new_file(result[i].file_name, result[i].file_id, "shared-content");
            }
        }
    });
}

function newFolder() {
    let foldername = document.getElementById("foldername").value;
    let path = document.getElementById("path-dir-drive").textContent;
    $.ajax({url: 'create-path' + path + "/" + foldername + '/' + token,
        success: function(result){
            change_path(path);
        }
    });
}

function newFile() {
    filename = document.getElementById("filename").value;
    console.log(filename);
}

function getInfo(file_id){
    $.ajax({url: 'get-info?file_id=' + file_id + '&token=' + token,
        success: function(result){
            show_info(result[0]);
        }
    });
}

function download(file_id){
    console.log("Download : " + file_id);
}